# coding: utf-8
from django.db import models


class AbstractStateModel(models.Model):

    NOT_SENT = 1
    SENT = 2
    ERROR = 3

    STATE = (
        (NOT_SENT, 'not sent'),
        (SENT, 'sent'),
        (ERROR, 'error'),
    )

    state = models.SmallIntegerField(
        choices=STATE, default=NOT_SENT, verbose_name=u"Состояние пакетов")

    class Meta:
        abstract = True
