# -*- coding: utf-8 -*-
from django.db import models

from aio_client.base.models import GetReceipt
from aio_client.base.models import RequestMessage


class PostConsumerRequest(RequestMessage):
    """Передача заявок в СМЭВ"""
    LIST_AIO_FIELDS = [
        "message_id",
        "body",
        "attachments",
        "message_type",
        "is_test_message",
    ]
    is_test_message = models.BooleanField(
        default=False, verbose_name=u'Признак тестового взаимодействия')


class GetConsumerResponse(RequestMessage):
    """Ответы из очереди СМЭВ"""
    LIST_AIO_FIELDS = [
        "message_id",
        "origin_message_id",
        "body",
        "attachments",
        "message_type",
    ]


class GetConsumerReceipt(GetReceipt):
    """Квитанций с результатом отправки запроса"""
    LIST_AIO_FIELDS = (
        "message_id",
        "error",
        "origin_message_id",
        "fault",
        "message_type",
    )
